AchievementTiedHands = class(Turbine.UI.Control)
function AchievementTiedHands:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.effectList = {
        ["Assailment"] = true,
    }

    self.skillList = {
        ["Hampering Javelin"] = true,
        ["Ambush"] = true,
        ["Warning Shot"] = true,
        ["Javelin of Deadly Force"] = true,
    }

    self.handler = handler
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.playerName = self.player:GetName()

    for i = 1, PlayerEffectsHandler:GetPlayerEffects():GetCount() do
        if self.effectList[PlayerEffectsHandler:GetPlayerEffects():Get(i):GetName()] then 

            self.handler:Fail()
        end
    end



    self.command = Turbine.ShellCommand()
    function self.command:Execute()
        HardcoreHandler:GetAchievementHint("Tied Hands")
    end

    Turbine.Shell.AddCommand("hardcoretiedhands", self.command)

    ChatOutput("Use the command /hardcoretiedhands to see a list of affected skills")
end

function AchievementTiedHands:SetCallbacks()
    self.effectCallback = AddCallback(PlayerEffectsHandler, "EffectAdded", function(effect)
        if self.effectList[effect:GetName()] then
            self.handler:Fail("Tied Hands", "Usage of ranged stance", 0x410E0DCA)
        end
    end)

    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then
            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Tied Hands", "Usage of javelin skill", 0x410E0DCA)
            end))
        end
    end
end

function AchievementTiedHands:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
    RemoveCallback(PlayerEffectsHandler, "EffectAdded", self.effectCallback)
end

function AchievementTiedHands:Refresh()
    self:Unload()
    self:SetCallbacks()
end

function AchievementTiedHands:GetHint()
    ChatOutput("<rgb=#005500>Only melee stance is allowed.")
    ChatOutput("<rgb=#FF0000>No javelin skills are allowed.")
end